/**
* @author H. Timucin Ozdemir
*/

import org.w3c.dom.*;

/**
* @author H. Timucin Ozdemir
* @date   February 18, 1999
*/
public class StudentRecord
{
   String ID;
   String name;
   String surname;
   String phone;
   String vCard;

   /**
   */
   public StudentRecord(Element ele) { extract(ele); }
  
   /** */
   public String getID() { return ID; }

   /** */
   public String getName() { return name; }

   /** */
   public String getSurname() { return surname; }

   /** */
   public String getVCard() { return vCard; }

   /**
   */
   void extract(Element ele)
   { 
     if( ele.getTagName().equals("student") ) 
     {
       org.w3c.dom.NamedNodeMap attribs = ele.getAttributes();
       org.w3c.dom.Attr a1 = (org.w3c.dom.Attr) attribs.getNamedItem("stdid");
       ID = a1.getValue();

       NodeList bList = ele.getElementsByTagName("name");
       if( bList!=null && bList.getLength()>0 ) extractName((Element)bList.item(0));

       bList = ele.getElementsByTagName("surname");
       if( bList!=null && bList.getLength()>0 ) extractSurname((Element)bList.item(0));

       bList = ele.getElementsByTagName("vcard");

       if( bList!=null && bList.getLength()>0 ) extractVCard((Element)bList.item(0));
       
     }// end of if

   }// end of extract()

   /**
   */
   void extractName(Element ele)
   { 
     if( ele.getTagName().equals("name") ) 
     {
       Node aNode = ele.getFirstChild();
       if( aNode.getNodeType() == Node.TEXT_NODE ) name = ((Text)aNode).getData();
     }// end of if
   }// end of extractName()

   /**
   */
   void extractSurname(Element ele)
   { 
     if( ele.getTagName().equals("surname") ) 
     {
       Node aNode = ele.getFirstChild();
       if( aNode.getNodeType() == Node.TEXT_NODE ) surname = ((Text)aNode).getData();
     }// end of if
   }// end of extractSurname()

   /**
   */
   void extractVCard(Element ele)
   { 
     if( ele.getTagName().equals("vcard") ) 
     {
       Node aNode = ele.getFirstChild();
       if( aNode.getNodeType() == Node.TEXT_NODE ) vCard = ((Text)aNode).getData();
     }// end of if
   }// endof extractVCard()

}// end of StudentRecord
