/**
* @author H. Timucin Ozdemir
*/

import org.w3c.dom.*;

/**
* @author H. Timucin Ozdemir
* @date   February 18, 1999
*/
public class StudentRecord
{
   String ID;
   String name;
   String surname;
   String phone;

   /**
   * @param ele an Element object.
   */
   public StudentRecord(Element ele) { extract(ele); }
  
   /** 
   * @return the <i>stdid</i> StudentRecord
   */
   public String getID() { return ID; }

   /**
   * @return the <i>name</i> StudentRecord 
   */
   public String getName() { return name; }

   /**
   * @return the <i>surname</i> StudentRecord 
   */
   public String getSurname() { return surname; }

   /**
   * Extracts the StudentRecord from the given Element object.
   * @param ele an Element object.
   */
   void extract(Element ele)
   { 
     if( ele.getTagName().equals("student") ) 
     {
       org.w3c.dom.NamedNodeMap attribs = ele.getAttributes();
       org.w3c.dom.Attr a1 = (org.w3c.dom.Attr) attribs.getNamedItem("stdid");
       ID = a1.getValue();

       NodeList bList = ele.getElementsByTagName("name");
       if( bList!=null && bList.getLength()>0 ) extractName((Element)bList.item(0));

       bList = ele.getElementsByTagName("surname");
       if( bList!=null && bList.getLength()>0 ) extractSurname((Element)bList.item(0));

     }// end of if

   }// end of extract()

   /**
   * Extracts the <i>name</i> from the given Element object.
   * @param ele an Element object.
   */
   void extractName(Element ele)
   { 
     if( ele.getTagName().equals("name") ) 
     {
       Node aNode = ele.getFirstChild();
       if( aNode.getNodeType() == Node.TEXT_NODE ) name = ((Text)aNode).getData();
     }// end of if
   }// end of extractName()

   /**
   * Extracts the <i>surname</i> from the given Element object.
   * @param ele an Element object.
   */
   void extractSurname(Element ele)
   { 
     if( ele.getTagName().equals("surname") ) 
     {
       Node aNode = ele.getFirstChild();
       if( aNode.getNodeType() == Node.TEXT_NODE ) surname = ((Text)aNode).getData();
     }// end of if
   }// end of extractName()

}// end of StudentRecord
