<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet  xmlns:xsl="http://www.w3.org/TR/WD-xsl"
xmlns:html="http://www.w3.org/TR/REC-html40/"
  result-ns="html">

<!-- Root Element -->

<xsl:template match="/">
 <xsl:process-children/>
</xsl:template>

<xsl:template match="/">
<HTML>

 <HEAD>

  <xsl:for-each select="title">
   <title>
   <xsl:process-children/>
   </title>
  </xsl:for-each>

 </HEAD>

 <body bgcolor="white">

 <xsl:process select="doc"/>

 </body>

</HTML>
</xsl:template>

<xsl:template match="doc">
 <xsl:sequence>

 <xsl:process select="title"/>

 <xsl:process select="abstract"/>

 <ol>
  <xsl:if test="section/title[first-of-type()]">Table Of Contents</xsl:if>
  <xsl:for-each select="section/title">
   <li>
   <xsl:process-children/>
   </li> 
  </xsl:for-each>
 </ol>

<!--
  <xsl:for-each select="section//figure">
   <xsl:element name="reffigure">

    <xsl:attribute name="rf">
    <xsl:number level="any" count="figure"/> 
    </xsl:attribute>

    <xsl:attribute name="figref">
    <xsl:value-of select="@ref"/>
    </xsl:attribute>

   </xsl:element>
  </xsl:for-each>
-->

<!--
  <xsl:for-each select="section//reffigure">
   <fo:block>
    <P>
    <xsl:number level="any" count="figure"/> 
    <xsl:text>. </xsl:text>
    <xsl:value-of select="@ref"/>
    </P>
   </fo:block>
  </xsl:for-each>
-->

  <xsl:if test="section//figure/title[first-of-type()]"> <h3>List of Figures</h3> </xsl:if>

  <xsl:for-each select="section//figure">
   <fo:block>
    <P>
    <xsl:number level="any" count="figure"/> 
    <xsl:text>. </xsl:text>
    <xsl:value-of expr="title"/>
    </P>
   </fo:block>
  </xsl:for-each>

 <xsl:process select="section"/>

 </xsl:sequence>
</xsl:template>

<!--
<xsl:template match="doc">

 <xsl:sequence>

 <xsl:process select="title"/>

 <ol>
  <xsl:for-each select="section//title">
   <p><li>
   <xsl:process-children/>
   </li> </p>
  </xsl:for-each>
 </ol>

 <xsl:process select="section">

 </xsl:sequence>

</xsl:template>
-->

<!--
<xsl:template match="doc/title">
 <center><h1>
 <font color="{attribute(color)}">
 <xsl:process-children/>
 </font>
 </h1></center>
</xsl:template>
-->

<xsl:template match="doc/title">
 <center><h1>
 <xsl:process-children/>
 </h1></center>
</xsl:template>

<xsl:template match="para">
 <p ALIGN="JUSTIFY">
 <xsl:process-children/>
 </p>
</xsl:template>

<xsl:template match="em">
 <I>
 <xsl:process-children/>
 </I>
</xsl:template>

<xsl:template match="em/em">
 <B>
 <xsl:process-children/>
 </B>
</xsl:template>

<xsl:template match="em/em/em">
 <I>
 <xsl:process-children/>
 </I>
</xsl:template>

<xsl:template match="figure">
 <center>
 <table>
 <!-- <tr><td>
      <B> Figure <xsl:number level="any" count="figure"/>.</B><BR/> -->
 <xsl:process select="graphic"/>
 <xsl:process select="title"/>
 <!-- </td></tr> -->
 </table>
 </center>
</xsl:template>

<xsl:template match="graphic">
 <tr><td> 
 <table bgcolor="{attribute(bgcolor)}" border="{attribute(border)}"><tr><td>
 <IMG src="{attribute(fileref)}"/>
 </td></tr> </table>
 </td></tr> 
</xsl:template>

<!-- Simple Graph
<xsl:template match="graphic">
 <tr><td> 
 <IMG src="{attribute(fileref)}"/>
 </td></tr> 
</xsl:template>
-->

<xsl:template match="figure/title">
 <tr><td> 
 <B>
 <i>Figure </i>
 <i><xsl:number level="any" count="figure"/> : </i>
 <xsl:process-children/>
 </B>
 </td></tr> 
</xsl:template>

<!--

<xsl:template match="section">
 <P><B>
 <xsl:number level="any" count="section"/>. </B><B> 
 <xsl:process-children/>
 </B></P>
</xsl:template>

-->

<xsl:template match="section">
 <xsl:process-children/>
</xsl:template>

<xsl:template match="section/title">
 <P><B>
 <xsl:number level="any" count="section" format="1. "/></B><B> 
 <xsl:process-children/>
 </B></P>
</xsl:template>

<!--
<xsl:template match="title">
 <P><B>
 <xsl:number level="multi" count="section|subsection" format="1.1.1 "/> </B><B> 
 <xsl:process-children/>
 </B></P>
</xsl:template>
-->

<!-- subsection's are bold -->
<xsl:template match="subsection//title">
 <P>
 <B>
 <xsl:number level="multi" count="section|subsection" format="1.1. "/></B><B> 
 <xsl:process-children/>
 </B>
 </P>
</xsl:template>

<!-- subsection's are red and italic -->
<!--
<xsl:template match="subsection//title">
 <P>
 <font color="red">
 <B>
 <xsl:number level="multi" count="section|subsection" format="1.1. "/></B><B> 
 <xsl:process-children/>
 </B>
 </font>
 </P>
</xsl:template>
-->

<!-- Abstract with dl list -->
<!--   
<xsl:template match="abstract">
 <P>
 <dl>
 <dt><b>Abstract</b> : </dt>
 <dd><P ALIGN="JUSTIFY"><i>
 <xsl:process-children/>
 </i></P></dd>
 </dl>
 </P>
</xsl:template>
-->


<!-- Abstract within table with limited column size and background -->
<!-- -->  
<xsl:template match="abstract">
 <P>
 <center>
 <table cellpadding="10" bgcolor="pink">
 <tr><td WIDTH="600">
 <P ALIGN="JUSTIFY"><i>
 <b>Abstract : </b>
 <xsl:process-children/>
 </i></P>
 </td></tr>
 </table>
 </center>
 </P>
</xsl:template>


<xsl:template match="itemize">
 <ol>
 <xsl:process-children/>
 </ol>
</xsl:template>

<xsl:template match="item">
 <p><li>
 <xsl:process-children/>
 </li></p>
</xsl:template>

<xsl:template match="verbose">
 <p><pre>
 <xsl:process-children/>
 </pre></p>
</xsl:template>

</xsl:stylesheet>
