<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet  xmlns:xsl="http://www.w3.org/TR/WD-xsl"
                 xmlns:html="http://www.w3.org/TR/REC-html40/"
                 xmlns:fo="http://www.w3.org/TR/WD-xsl"
                 result-ns="html">

<!-- Root Element -->

<xsl:template match="doc">
<HTML>

 <HEAD>

  <xsl:for-each select="title">
   <title> <xsl:value-of select="."/> </title>
  </xsl:for-each>
<!--
  <xsl:for-each select="section//figure">
   <xsl:element name="reffigure">

    <xsl:attribute name="rf">
    <xsl:number level="any" count="figure"/> 
    </xsl:attribute>

    <xsl:attribute name="figref">
    <xsl:value-of select="@ref"/>
    </xsl:attribute>

   </xsl:element>
  </xsl:for-each>
-->

 </HEAD>

 <body bgcolor="white">

 <xsl:sequence>

 <xsl:apply-templates select="reffigure">
  <xsl:value-of select="@rf"/>
  <xsl:value-of select="@figref"/>
 </xsl:apply-templates>

 <xsl:apply-templates select="title"/>

 <xsl:apply-templates select="abstract"/>

 <ol>
  <xsl:if test="section/title[first-of-type()]">Table Of Contents</xsl:if>
  <xsl:for-each select="section/title">
   <li>
   <xsl:apply-templates/>
   </li> 
  </xsl:for-each>
 </ol>

 <xsl:if test="section//figure/title[first-of-type()]">
  <h3>List of Figures</h3>
 </xsl:if>

 <xsl:for-each select="figure">
   <fo:block>
    <P>
    <xsl:number level="any" count="figure"/> 
    <xsl:text>. </xsl:text>
    <xsl:value-of select="title"/>
    </P>
   </fo:block>
 </xsl:for-each>

 <xsl:process select="section"/>
 
 <xsl:apply-templates select="section"/>

 </xsl:sequence>

 </body>

</HTML>
</xsl:template>

<xsl:template match="doc/title">
 <center><h1>
 <xsl:apply-templates/>
 </h1></center>
</xsl:template>

<xsl:template match="figref">
 <!--
 <xsl:value-of select="ancestor(doc)/listoffigures/reffigure[@figref='{@ref}']/@rf"/> 
 -->
 <xsl:value-of select="@ref"/>
</xsl:template>

<xsl:template match="para">
 <p ALIGN="JUSTIFY">
 <xsl:apply-templates/>
 </p>
</xsl:template>

<xsl:template match="em">
 <I> <xsl:apply-templates/> </I>
</xsl:template>

<xsl:template match="em/em">
 <B> <xsl:apply-templates/> </B>
</xsl:template>

<xsl:template match="em/em/em">
 <I> <xsl:apply-templates/> </I>
</xsl:template>

<xsl:template match="figure">
 <center>
 <table>
 <xsl:apply-templates select="graphic"/>
 <xsl:apply-templates select="title"/>
 <tr><td>
  <xsl:value-of select=".//listoffigures/reffigure[@figref='{@ref}']/@rf"/> 
 </td></tr> 
 </table>
 </center>
</xsl:template>

<!-- Simple Graph -->
<xsl:template match="graphic">
 <tr><td><IMG src="{@fileref}"/></td></tr> 
</xsl:template>

<xsl:template match="figure/title">
 <tr><td> 
 <B>
 <i>Figure </i>
 <i><xsl:number level="any" count="figure"/> : </i>
 <xsl:apply-templates/>
 </B>
 </td></tr> 
</xsl:template>

<xsl:template match="section">
 <xsl:apply-templates/>
</xsl:template>

<xsl:template match="section/title | subsection/title ">
 <P><B>
 <xsl:number level="multi" count="section|subsection" format="1.1. "/>
 <xsl:apply-templates/>
 </B></P>
</xsl:template>

<!-- subsection's are red and italic -->
<!--
<xsl:template match="subsection//title">
 <P>
 <font color="red">
 <B>
 <xsl:number level="multi" count="section|subsection" format="1.1. "/></B><B> 
 <xsl:value-of select="."/>
 </B>
 </font>
 </P>
</xsl:template>
-->

<!-- Abstract with dl list -->
<!--   
<xsl:template match="abstract">
 <P>
 <dl>
 <dt><b>Abstract</b> : </dt>
 <dd><P ALIGN="JUSTIFY"><i>
 <xsl:apply-templates/>
 </i></P></dd>
 </dl>
 </P>
</xsl:template>
-->


<!-- Abstract within table with limited column size and background -->
<!-- -->  
<xsl:template match="abstract">
 <P>
 <center>
 <table cellpadding="10" bgcolor="pink">
 <tr><td WIDTH="600">
 <P ALIGN="JUSTIFY"><i>
 <b>Abstract : </b>
 <xsl:apply-templates/>
 </i></P>
 </td></tr>
 </table>
 </center>
 </P>
</xsl:template>

<xsl:template match="itemize">
 <ol>
 <xsl:apply-templates/>
 </ol>
</xsl:template>

<xsl:template match="item">
 <p><li>
 <xsl:apply-templates/>
 </li></p>
</xsl:template>

<xsl:template match="verbose">
 <p><pre>
 <xsl:apply-templates/>
 </pre></p>
</xsl:template>

</xsl:stylesheet>
