package edu.npac.iwt;

import java.io.*;
import java.util.*;

import iwt.web.server.*;

/**
*
* @see edu.npac.iwt.HttpBaseResource
* @see edu.npac.iwt.HttpResource
*
*/
public class 
FileResource extends HttpBaseResource implements HttpResource 
{
    
   public static final boolean DEBUG = false;
    
   protected HttpServer aServer;
   protected String     fSeparator;

   public FileResource(HttpServer _aServer) 
   { 
     aServer    = _aServer;
     fSeparator = System.getProperty("file.separator");
  
   }

   public FileResource() 
   { 
     aServer    = null;
     fSeparator = System.getProperty("file.separator");
  
   }

   public void setServer(HttpServer _aServer) 
   { 
     aServer    = _aServer;
   }

   public void 
   handleResource(Properties sProps, String resourceName, QueryString qStr, 
                  OutputStream ous, Properties props, HttpRequest req)
   {    
      PrintStream os = new PrintStream(ous);
      File file = new File(aServer.getRootDirectory()+resourceName);

      props.list(System.out);
      if( file.exists() && file.canRead() )
      {
          if( file.isDirectory() )
          {
             String rName = resourceName;
             if( !rName.endsWith("/") ) rName += "/"; 
             System.out.println("rName " + rName );  
             String newfilename = aServer.getRootDirectory()+
                                  rName+"index.html";
             File theFile = new File(newfilename);
             if( theFile.exists() && theFile.canRead() ) 
                  serveFile(newfilename,os);
             else 
               { String UserAgent = (String)props.get("User-Agent");
                 if( UserAgent.startsWith("TinyBrowser") )
                      serveDirectoryForTinyBrowser(rName,os);
                 else serveDirectory(rName,os);
               }

          } 
          else serveFile(aServer.getRootDirectory()+resourceName,os);

      }
      else 
        {  // can't find the file
           printHeader(os,"404 File Not Found");
           os.println("<HTML><HEAD><TITLE>File Not Found</TITLE></HEAD>");
           os.println("<BODY><H1>HTTP Error 404: File Not Found</H1></BODY></HTML>");
           os.close();
        } 
    
   }// end of handleResource()

   /**
   */
   public void 
   serveFile(String fileName, PrintStream os)
   {
      try 
      {   
          int l;
          File theFile = new File(fileName);
          FileInputStream fis = new FileInputStream(theFile);
          byte[] theData = new byte[1024] ;

          // need to check the number of bytes read here
          String ct = guessContentTypeFromName(fileName);
         
          System.out.println(fileName+":"+ct);
          // send the Header
          printHeader(os, new Date(), ct, theFile.length() ,"200 OK");

          while((l=fis.read(theData))!=-1) os.write(theData,0,l);
                   
          // send the file
          os.flush();
          //os.close();
          fis.close();

      } catch (IOException e) 
        {  // can't find the file
           printHeader(os,"404 File Not Found");
           os.println("<HTML><HEAD><TITLE>File Not Found</TITLE></HEAD>");
           os.println("<BODY><H1>HTTP Error 404: File Not Found</H1></BODY></HTML>");
           os.close();
           System.out.println("404 File Not Found");
        }

   }// end of serveFile()

   /**
   * Serves the Directory request.
   */
   void 
   serveDirectory(String fileName, PrintStream os1)
   {
     int i;  
     ByteArrayOutputStream bos = new ByteArrayOutputStream();
     PrintStream os = new PrintStream(bos);
     File file      = new File(aServer.getRootDirectory()+fSeparator+fileName);

     /**********************************/
     /** Make sure base ends width '/' *
     /**********************************/
     int lIndx = fileName.lastIndexOf('/');
     String base = new String();//aServer.getRootDirectory());
     if(lIndx>=0&&lIndx<fileName.length()) 
        base += fileName.substring(0,lIndx+1);
     if( !base.endsWith("/") ) base +="/";

     //System.out.println("<base>"+aServer.getServerAddress()+":"+
     //               aServer.getServerPort()+"</base>");
     
     try
     {
        os.println("<html>");
        String str ;
        String[] files = file.list();
        File f;
        System.out.println("Directory of " + base + " \n");
        if(base.length() == 1)
        {
           os.println("<title>Root directory</title>");
           //os.println("<base>"+aServer.getRootDirectory()+"</base>");
           os.println("<body> <p> Root directory ");
        }
        else
         {
           os.println("<title>Directory of "+base+"</title>");
           //os.println("<base>"+aServer.getRootDirectory()+"</base>");
           os.println("<body> <p> <b>Directory of </b>"+base+"<br>\r\n");
           //if(DEBUG) System.out.println("Directory of " + base + " <br>\r\n");

           /**************************************************/
           /** construct href for each element of base path: */
           /**************************************************/

           int j; i = 1;
           int last_slash = base.lastIndexOf('/');
           os.print("<i>Up to</i>  ");
           os.print(getLink("/","/"));
           String href;
           String label;

           if(last_slash==base.length()) 
              last_slash = base.lastIndexOf('/',last_slash-1);  


           /***********************************************/
           /** construct a links to the upper directories */
           /***********************************************/
           while ((j = base.indexOf('/', i) + 1) < last_slash)
           {

              os.print(" ,  ");
              href = base.substring(0, j);
              label = base.substring(i, j);
              os.print(getLink(href,label));
              if(DEBUG) System.out.println(" href : "+href+"  label : "+label);
              i = j;

           }// end of while

        }

        os.println("\r\n <p> <table border=2>");

        /****************************************************/
        /** If there are some elements then we need headers */
        /****************************************************/
        if(files.length>0)
        {
           os.println("\r\n <tr> <td> File Name </td> <td> Size </td> ");
           os.println(" <td> Type </td> <td> Last Nodified </td> </tr> \r\n");

        }// end of if

        /***********************************/
        /** For each file in the directory */
        /***********************************/
        //for(int i = 0; i < files.length; i++)
        for(i = 0; i < files.length; i++)
        {
            os.println("<tr>\r\n");
            f = new File(file, files[i]);

            /***************/
            /** print Name */
            /***************/
            if(f.isDirectory())
            {
               os.println("  <td><A HREF=\"" + base + files[i] + '/' +"\">"+ files[i] + "</A></td>\r\n");
               
            }
            else
             {
                os.println("  <td>");
                str = getLink(base + files[i],files[i]);
                os.println(str + "</td>\r\n");
             }


            /***************/
            /** print size */
            /***************/
            if(f.isFile())
               os.println("  <td nowrap align=right>" + f.length() + " bytes</td>\r\n ");
            else
               os.println("  <td></td>\r\n");

            /***************/
            /** print Type */
            /***************/
            if (f.isFile())
            {
               String typ = guessContentTypeFromName(files[i]);
               os.println("  <td align=center>&#160;" + typ + "&#160;</td>\r\n");
            } 
            else if(f.isDirectory())
                 os.println("  <td align=center>DIR</td>\r\n");
            else
                 os.println("  <td align=center>?</td>\r\n");

            /************************/
            /** print Last Modified */
            /************************/
            os.println("  <td nowrap align=right>");
            os.println(new Date(f.lastModified()).toGMTString());
            os.println("</td>\r\n");

            os.println("</tr>\r\n");
            //if(DEBUG) System.out.println(" i : "+i);

        }// end of for

       //if(DEBUG) System.out.println(" There are "+files.length+" number of files af ter list");
       os.println("</table>");
       os.println("<p><i>Processed by TinyServer 1.0 </i></p>");
       os.println("</body> </html>");
       os.flush();

       byte[] theData = bos.toByteArray();

       // send the Header
       printHeader(os1, new Date(), "text/html", theData.length ,"200 OK");
                   
       // send the file
       os1.write(theData);
       os1.close();

     } catch(IOException ioe)
       { //ioe.printStackTrace(); 
       }

  }// end of servingDir()

  String
  getLink(String Link, String label)
  {
     String str;

     str = new String("<A HREF=\"");
     str += Link ;
     str += "\">" ;
     str += label ;
     str += "</A>";

     return str;

  }// end of getLink()

   /**
   * Serves the Directory request.
   */
   void serveDirectoryForTinyBrowser(String fileName, PrintStream os1)
   {
     int i;  
     ByteArrayOutputStream bos = new ByteArrayOutputStream();
     PrintStream os = new PrintStream(bos);
     File file      = new File(aServer.getRootDirectory()+fSeparator+fileName);

     /**********************************/
     /** Make sure base ends width '/' *
     /**********************************/
     int lIndx = fileName.lastIndexOf('/');
     String base = new String();
     if(lIndx>=0&&lIndx<fileName.length()) 
        base += fileName.substring(0,lIndx+1);
     if( !base.endsWith("/") ) base +="/";
     
     try
     {
        os.println("<?xml version='1.0'?>");
        os.println("<?axml-stylesheet href=\"http://"
                   +aServer.getServerAddress()+":"+aServer.getServerPort()
                   +"/xsl/dir.xsl\" text=\"text/xsl\"?>");
        os.println("<directory>");
        os.println("<xml-stylesheet href=\"http://"
                   +aServer.getServerAddress()+":"+aServer.getServerPort()
                   +"/xsl/dir.xsl\" text=\"text/xsl\"/>");
        String str ;
        String[] files = file.list();
        File f;
        System.out.println("Directory of " + base + " \n");
        os.println("<base>http://"+aServer.getServerAddress()+":"+
                    aServer.getServerPort()+"/"+base+"</base>");
        if(base.length() == 1)
           os.println("<title>Root directory</title>");
        else
         {
           os.println("<title>Directory of "+base+"</title>");
           os.println("<ances name='/'>");

           //**************************************************
           //** construct href for each element of base path: *
           //**************************************************

           int j,k=0; i = 1;
           int last_slash = base.lastIndexOf('/');

           //os.print("<i>Up to</i>  ");
           //os.print(getLink("/","/"));

           String href;
           String label;

           if(last_slash==base.length()) 
              last_slash = base.lastIndexOf('/',last_slash-1);  


           //***********************************************
           //** construct a links to the upper directories *
           //***********************************************
           while ((j = base.indexOf('/', i) + 1) < last_slash)
           {

              //os.println("<ances>");
              //os.print(" ,  ");
              href = base.substring(0, j);
              label = base.substring(i, j);
              //os.print(getLink(href,label));
              if(DEBUG) System.out.println(" href : "+href+"  label : "+label);
              i = j;
              os.println("<ances "+" name=\""+label+"\">");
              k++; //os.println("</ances>");

           }// end of while
           for(i=0;i<k;i++) os.println("</ances>");

           os.println("</ances>");

        }

        /***********************************/
        /** For each file in the directory */
        /***********************************/
        for(i = 0; i < files.length; i++)
        {
            f = new File(file, files[i]);

            /***************/
            /** print Name */
            /***************/
            if(f.isDirectory())
            {
               os.println("<resource>");
               os.println("<type>DIR</type>");
               os.println("<name>"+files[i]+"</name>");
               os.print("<date>");
               os.print(new Date(f.lastModified()).toGMTString());
               os.println("</date>");
               os.println("</resource>");
               
            }
            else
             {
               os.println("<resource>");
               os.println("<name>"+files[i]+"</name>");

               os.print("<date>");
               os.print(new Date(f.lastModified()).toGMTString());
               os.println("</date>");

               os.println("<length>"+f.length()+"</length>");

               os.println("<type>"+guessContentTypeFromName(files[i])+"</type>");
               os.println("</resource>");
             }

        }// end of for

       os.println("</directory>");
       os.flush();

       byte[] theData = bos.toByteArray();

       // send the Header
       printHeader(os1, new Date(), "text/xml", theData.length ,"200 OK");
                   
       // send the file
       os1.write(theData);
       os1.close();

     } catch(IOException ioe) 
       { //ioe.printStackTrace(); 
       }

  }// end of servingDir()

}// end of FileResource()
