package edu.npac.iwt;

import java.net.*;
import java.io.*;
import java.util.*;

import iwt.web.server.*;

/**
*/
public class 
TServer extends HttpBaseResource implements Runnable, HttpServer
{

  public static final String rootTxt = "-root";
  public static final String portTxt = "-port";
  public static final String propTxt = "-prop";


  Socket theConnection;
  static File docroot;
  static String indexfile = "index.html";

  int    portNumber;
  Properties aProp;

  Thread runner;
 
  Hashtable prefixResources = new Hashtable();
  Hashtable extentionResources = new Hashtable();
  
  /**
  */
  public TServer(Socket _theConnection, File _docroot, int _pn, Properties _aProp ) 
  {
    theConnection = _theConnection;
    docroot       = _docroot;
    portNumber = _pn;
    aProp      = _aProp;
    String res = aProp.getProperty("uriprefix.resource");
    if(res!=null) loadResources(res,prefixResources);
    res = aProp.getProperty("uriextention.resource");
    if(res!=null) loadResources(res,extentionResources);

  }// end of CONSTRUCTOR

  /**
  */
  public int getServerPort() { return portNumber; }

  /**
  * Returns the host name of the server.
  */
  public synchronized String
  getServerAddress()
  {
      String host = null;
      InetAddress addr;
      try
      {
        addr = InetAddress.getLocalHost();

        host = addr.getHostName();
        if (host == null || host.indexOf('.') == -1)
        {
           /****************************************************/
           /** If host does not appear to be fully qualified,  */
           /** then return just the inet address instead.      */
           /****************************************************/
           host = addr.getHostAddress();

        }// end of if

      } catch (UnknownHostException e)
        { return null; }

      return host;

  }// end of findHostname()

  /**
  */
  public void 
  start()
  {
    if(runner==null) runner = new Thread(this);
    runner.start();

  }// end of start()
 
  /** 
  */
  public void 
  stop()
  {
    if(runner!=null) runner.stop();
    runner = null;
  }// end of stop()

  /**
  */
  public void 
  run() 
  {
  
    String method;
    String ct;
    String version = "";
    File theFile;
    HttpResource aHandler = new FileResource(this);
    HttpResource bHandler = new XMLEHandler(this);
    
    try 
    {
      Properties props = new Properties();
      PrintStream os = new PrintStream(theConnection.getOutputStream());
      DataInputStream is = new DataInputStream(theConnection.getInputStream());
      String get ;
      boolean keepAlive = false;

      do 
      { 
        if( (get = is.readLine())!=null )
        {
          HttpRequest httpReq = new HttpRequest(get);
          method = httpReq.getMethod();
          String file = httpReq.getUri();

          if (method.equals("GET"))
          {
            System.out.println("file:"+file);

            // Guess the file name
            ct = guessContentTypeFromName(file);

            // Get the Protocol Version Info
            version = httpReq.getProtocol();
        
            // loop through the rest of the input lines 
            while ((get = is.readLine()) != null)
            {
              if (get.trim().equals("")) break;        
              System.out.println(get);
              props.put( get.substring(0,get.indexOf(':')).trim(),
                         get.substring(get.indexOf(':')+1).trim() );
            }// end of while
 
            // Build the QueryString
            QueryString querStr = new QueryString();
            querStr.buildQueryString(httpReq.getQStr());

            String hReq = docroot+"\\"+file.substring(1,file.length());
            System.out.println("uri:"+hReq);
      
            // Get the extention of the file
            String extention = getExtention(file);

            // Set the input stream for HttpRequest
            httpReq.setInputStream(is); 

            // Find proper handler
            if( extention!=null && extention.endsWith("xml")) 
                bHandler.handleResource(aProp,docroot+file.substring(0,file.length()),
                                        querStr,os,props,httpReq);
            else
                aHandler.handleResource(aProp,file.substring(0,file.length()),
                                        querStr,os,props,httpReq);

            os.flush();
            extention = props.getProperty("Connection");
            keepAlive = (extention!=null && extention.equals("Keep-Alive"));
            System.out.println("keepAlive:"+keepAlive);

          } else 
            {  // method does not equal "GET"
               if (version.startsWith("HTTP/")) printHeader(os,"501 Not Implemented");
               os.println("<HTML><HEAD><TITLE>Not Implemented</TITLE></HEAD>");
               os.println("<BODY><H1>HTTP Error 501: Not Implemented</H1></BODY></HTML>");
               os.close();
            }
        }// end of if 

      } while ( keepAlive );
   
    } catch (IOException e) { }
    
    try 
    {
      theConnection.close();
    } catch (IOException e) { }

  }// end of run
 
  /**
  */
  public String 
  getProperty(String propName) { return aProp.getProperty(propName); }

  /**
  */
  public void setProperty(String propName, String propValue) {  }

  /**
  */
  public String getRootDirectory() { return docroot.getPath(); }

  /**
  */
  public String 
  getExtention(String file)
  {
    String ret = null;
    int lIndex = file.lastIndexOf(".");
    if( lIndex>=0 && lIndex<file.length() )
        ret = file.substring(lIndex+1,file.length());
    
    return ret;

  }// end of getExtention()

  void loadResources(String fileName, Hashtable resourceTable)
  {
     try
     { Properties p = new Properties();
       p.load(new FileInputStream(fileName));
       Enumeration e = p.keys();
       while( e.hasMoreElements() )
       {
         String className = null;
         String resKey = (String) e.nextElement();
         if( resKey!=null ) className = (String) p.get(resKey);

         if( className!=null )
         { 
            try
            {
               // Get Class Object
               java.lang.Class cl = Class.forName(className); 

               Object res = cl.newInstance();
               if( res instanceof HttpResource )
               { ((HttpResource)res).setServer(this);resourceTable.put(resKey,res); }
                 
            } catch(java.lang.ClassNotFoundException cnf) 
              { System.out.println(" ClassNotFoundException!" ); }
              catch(java.lang.InstantiationException cnf) 
              { System.out.println(" InstantiationException!" ); }
              catch(java.lang.IllegalAccessException cnf) 
              { System.out.println(" IllegalAccessException!" ); }

         }// end of if
 
       }// end of while()

     } catch(Exception e) {}

  }// end of loadResources()

  /**
  */
  public static void 
  main(String[] args) 
  {

    int i, cnt =0;
    int thePort= 80, aPortNumber;
    ServerSocket ss;
    File docroot = new File("."); 
    String propName = "server.properties";

    for(i=0;i<args.length;i++)
    {
      
           if(args[i].equals(TServer.rootTxt) )
           {
              // get the Document root
              try 
              {
                docroot = new File(args[i+1]);
              } catch (Exception e) { docroot = new File("."); }
           }
      else if(args[i].equals(TServer.portTxt) ) 
           { 
              // set the port to listen on
              try 
              {
                 aPortNumber = Integer.parseInt(args[i+1]);
                 if ( aPortNumber > 0 && aPortNumber < 65555 ) thePort = aPortNumber;
              } catch (Exception e) { }
           }
      else if(args[i].equals(TServer.propTxt) )
           {
              // get the Document root
              try 
              {
                propName = args[i+1];
              } catch (Exception e) { propName = "server.properties"; }
           }

    }// end of for
            
    try 
    {
      ss = new ServerSocket(thePort);
      System.out.println("Accepting connections on port : " + ss.getLocalPort());
      System.out.println("Document Root ................: " + docroot);

      // Get the settings
      Properties props = new Properties();
      props.load(new FileInputStream(propName));

      while (true) 
      {
        TServer j = new TServer(ss.accept(),docroot,thePort,props);
        System.out.println(" I got connection "+cnt);
        j.start();
        cnt++;
      }

    } catch (IOException e) 
      { System.err.println("Server aborted prematurely"); }
  
  }// end of main()

}
