package edu.npac.iwt;

import java.net.*;
import java.io.*;
import java.util.*;

import iwt.web.server.*;

/**
*/
public class 
TServer extends HttpBaseResource implements Runnable, HttpServer
{

  public static final String rootTxt = "-root";
  public static final String portTxt = "-port";
  public static final String propTxt = "-prop";


  Socket theConnection;
  static File docroot;
  static String indexfile = "index.html";

  int    portNumber;
  Properties aProp;

  Thread runner;
  
  public TServer(Socket _theConnection, File _docroot, int _pn, Properties _aProp ) 
  {
    theConnection = _theConnection;
    docroot       = _docroot;
    portNumber = _pn;
    aProp      = _aProp;

  }

  public int getServerPort() { return portNumber; }

  /**
  * Returns the host name of the server.
  */
  public synchronized String
  getServerAddress()
  {
      String host = null;
      InetAddress addr;
      try
      {
        addr = InetAddress.getLocalHost();

        host = addr.getHostName();
        if (host == null || host.indexOf('.') == -1)
        {
           /****************************************************/
           /** If host does not appear to be fully qualified,  */
           /** then return just the inet address instead.      */
           /****************************************************/
           host = addr.getHostAddress();

        }// end of if

      } catch (UnknownHostException e)
        { return null; }

      return host;

  }// end of findHostname()

  public void 
  start()
  {
    if(runner==null) runner = new Thread(this);
    runner.start();

  }// end of start()
 
  public void 
  stop()
  {
    if(runner!=null) runner.stop();
    runner = null;
  }// end of stop()

  public void 
  run() 
  {
  
    String method;
    String ct;
    String version = "";
    File theFile;
    HttpResource aHandler = new FileResource(this);
    HttpResource bHandler = new XMLEHandler(this);
    
    try 
    {
      Properties props = new Properties();
      PrintStream os = new PrintStream(theConnection.getOutputStream());
      DataInputStream is = new DataInputStream(theConnection.getInputStream());
      String get = is.readLine();
      StringTokenizer st = new StringTokenizer(get);
      method = st.nextToken();
      if (method.equals("GET")) {
        String file = st.nextToken();
        System.out.println("file:"+file);
        //if (file.endsWith("/")) file += indexfile;
        ct = guessContentTypeFromName(file);
        if (st.hasMoreTokens()) {
          version = st.nextToken();
        }
        // loop through the rest of the input lines 
        
        while ((get = is.readLine()) != null) {
          if (get.trim().equals("")) break;        
          System.out.println(get);
          props.put( get.substring(0,get.indexOf(':')).trim(),
                     get.substring(get.indexOf(':')+1).trim() );
        }
 
        QueryString querStr = new QueryString();
        int aIndex = file.indexOf('?');
        if(aIndex>0 && aIndex<file.length())
        {  
           querStr.buildQueryString(file.substring(aIndex+1,file.length()));
           file    = file.substring(0,aIndex);
        }
        String hReq = docroot+"\\"+file.substring(1,file.length());
        System.out.println("uri:"+hReq);
      
        String extention = getExtention(file);

        if( extention!=null && extention.endsWith("xml")) 
            bHandler.handleResource(aProp,docroot+file.substring(0,file.length()),querStr,os,props);
        else
            aHandler.handleResource(aProp,file.substring(0,file.length()),querStr,os,props);


      }
      else 
      {  // method does not equal "GET"
        if (version.startsWith("HTTP/")) printHeader(os,"501 Not Implemented");
        os.println("<HTML><HEAD><TITLE>Not Implemented</TITLE></HEAD>");
        os.println("<BODY><H1>HTTP Error 501: Not Implemented</H1></BODY></HTML>");
        os.close();
      }
    }
    catch (IOException e) { }
    
    try 
    {
      theConnection.close();
    } catch (IOException e) { }

  }
 
  public String 
  getProperty(String propName)
  {
     return null;
  }

  public void   
  setProperty(String propName, String propValue)
  {
  }

  public String getRootDirectory() { return docroot.getPath(); }

  public String 
  getExtention(String file)
  {
    String ret = null;
    int lIndex = file.lastIndexOf(".");
    if( lIndex>=0 && lIndex<file.length() )
        ret = file.substring(lIndex+1,file.length());
    
    return ret;
  }

  public static void 
  main(String[] args) 
  {

    int i, cnt =0;
    int thePort= 80, aPortNumber;
    ServerSocket ss;
    File docroot = new File("."); 
    String propName = "server.properties";

    for(i=0;i<args.length;i++)
    {
      
           if(args[i].equals(TServer.rootTxt) )
           {
              // get the Document root
              try 
              {
                docroot = new File(args[i+1]);
              } catch (Exception e) { docroot = new File("."); }
           }
      else if(args[i].equals(TServer.portTxt) ) 
           { 
              // set the port to listen on
              try 
              {
                 aPortNumber = Integer.parseInt(args[i+1]);
                 if ( aPortNumber > 0 && aPortNumber < 65555 ) thePort = aPortNumber;
              } catch (Exception e) { }
           }
      else if(args[i].equals(TServer.propTxt) )
           {
              // get the Document root
              try 
              {
                propName = args[i+1];
              } catch (Exception e) { propName = "server.properties"; }
           }

    }// end of for
            
    try 
    {
      ss = new ServerSocket(thePort);
      System.out.println("Accepting connections on port : " + ss.getLocalPort());
      System.out.println("Document Root ................: " + docroot);

      // Get the settings
      Properties props = new Properties();
      props.load(new FileInputStream(propName));

      while (true) 
      {
        TServer j = new TServer(ss.accept(),docroot,thePort,props);
        System.out.println(" I got connection "+cnt);
        j.start();
        cnt++;
      }

    } catch (IOException e) 
      { System.err.println("Server aborted prematurely"); }
  
  }// end of main()

}
