package edu.npac.iwt.dom;

import java.io.*;
import java.net.*;
import java.util.*;
import org.w3c.dom.*;

//
//
// Freedom
//
//
public class Freedom
{
	FreedomDriver		driver;

		public
	Freedom (String name)
	{
		setDriver(name);
	}

		public FreedomDriver
	getDriver ()
	{
		return driver;
	}

		public void
	setDriver (String name)
	{
		try
		{
			Class clazz = Class.forName(name);
			Object instance = clazz.newInstance();
			
			if (!(instance instanceof FreedomDriver))
				throw new IllegalArgumentException("Class named " + name +
					" is not a FreedomDriver");

			driver = (FreedomDriver)instance;
		}
		catch (Exception ex)
		{
			System.out.println(ex);
			ex.printStackTrace();
		}
	}

		public Object
	getProperty (String name)
	{
		return driver != null ? driver.getProperty(name) : null;
	}

		public void
	setProperty (String name, Object value)
	{
		if (driver != null)
			driver.setProperty(name, value);
	}

		public Throwable
	getError ()
	{
		return driver != null ? driver.getError() : null;
	}

		public Object
	getDriverProperty (String name)
	{
		return getProperty(name);
	}

		public void
	setDriverProperty (String name, Object value)
	{
		setProperty(name, value);
	}

		public Throwable
	getDriverError ()
	{
		return getError();
	}

		public Document
	createDocument (String type)
	{
		if (driver.hasFeature(type, "1.0"))
		{
			FreedomDocument doc = new FreedomDocument();
			doc.setDOMImplementation(driver);
			doc.setDocumentElement(new FreedomElement(type));
			return doc;
		}
		else
			return null;
	}

		public Document
	openDocument (Object source)
	{
        System.out.println(" hello "+source);
		Document result = null;
		if (driver != null)
			result = driver.read(source);
		return result;
	}

// package private method

		static final DOMException
	exception (int code)
	{
		IWTDOMException ex = new IWTDOMException(code);
		//ex.code = code;
		return ex;
	}
}
