package edu.npac.iwt.dom;

import java.util.*;
import org.w3c.dom.*;

//
//
// FreedomContainer
//
//
public abstract class FreedomContainer extends FreedomComponent
{
	FreedomNodeList		list;

		public
	FreedomContainer (short type)
	{
		super(type);
	}

// org.w3c.dom.Node implementation methods

		public NodeList      
	getChildNodes()
	{
		if (list == null)
			list = new FreedomNodeList();

		return list;
	}

		public Node              
	getFirstChild()
	{
		return list != null ? (Node)list.firstElement() : null;
	}

		public Node              
	getLastChild()
	{
		return list != null ? (Node)list.lastElement() : null;
	}

   public Node              
   insertBefore(Node newChild, Node refChild) throws DOMException
   {
      Node ret = null;
	if (list == null) list = new FreedomNodeList();

	if( newChild != null)
	{
          //if ( refChild.getOwnerDocument() != getOwnerDocument() )
          //     throw new IWTDOMException(DOMException.WRONG_DOCUMENT_ERR);
          if ( refChild == null ) list.addElement(newChild);
          else
           {
              if(!list.contains(refChild))
                   throw new IWTDOMException(DOMException.NOT_FOUND_ERR);
              else list.insertElementAt(newChild,list.indexOf(refChild));
           }

    	    ((FreedomComponent)newChild).parent = this;
          ((FreedomComponent)newChild).setOwnerDocument(getOwnerDocument());
 
	    ret = newChild;

	}// end of if

      return ret;

   }// end of insertBefore()

   /**
   */
   public Node
   replaceChild(Node newChild, Node oldChild) throws DOMException
   {
	if( oldChild == null || !list.contains(oldChild) || 
          oldChild.getParentNode() != this)
	    throw new IWTDOMException(DOMException.NOT_FOUND_ERR);

      if( newChild == null || newChild.getOwnerDocument() != getOwnerDocument())
	    throw new IWTDOMException(DOMException.WRONG_DOCUMENT_ERR);


	list.setElementAt(newChild, list.indexOf(oldChild));

	((FreedomComponent)newChild).parent = this;
	((FreedomComponent)oldChild).parent = null;
      ((FreedomComponent)newChild).setOwnerDocument(getOwnerDocument());

	return oldChild;

   }// end of replaceChild()

   public Node              
   removeChild(Node oldChild) throws DOMException
   {
	if (oldChild == null || oldChild.getParentNode() != this)
		throw new IWTDOMException(DOMException.NOT_FOUND_ERR);

	list.removeElement(oldChild);
	((FreedomComponent)oldChild).parent = null;

	return oldChild;

   }// end of removeChild()

   public Node
   appendChild(Node newChild) throws DOMException
   {
	if (list == null) list = new FreedomNodeList();

	list.addElement(newChild);
	((FreedomComponent)newChild).parent = this;
	((FreedomComponent)newChild).setOwnerDocument(getOwnerDocument());

	return newChild;

   }// end of appendChild()

	public boolean
	hasChildNodes()
	{
		return list != null ? list.size() > 0 : false;
	}

	public Node               
	cloneNode(boolean deep)
	{
		return null;	//TODO
	}

		public boolean            
	equals(Node arg, boolean deep)
	{
		return true;	//TODO
	}

// Implementation methods

		Node
	prevChild (Node refChild)
	{
		return list.item(list.indexOf(refChild) - 1);
	}

		Node
	nextChild (Node refChild)
	{
		return list.item(list.indexOf(refChild) + 1);
	}
}

