package edu.npac.iwt.dom;

import org.w3c.dom.*;

//
//
// FreedomData
//
//
public abstract class FreedomData extends FreedomComponent
	implements CharacterData
{
	static final String				EMPTYSTRING = "";

	FreedomTextBuffer				dataBuffer;
	String							dataString;

		public
	FreedomData (short type)
	{
		this(type, EMPTYSTRING);
	}

		public
	FreedomData (short type, String data)
	{
		super(type);

		dataBuffer = null;
		dataString = data;
	}

		public String
	toString ()
	{
		if (dataString == null)
			dataString = dataBuffer.toString();
		
		return dataString;
	}

// org.w3c.dom.Node impl.

		public String
	getNodeValue ()
	{
		return getData();
	}

		public void
	setNodeValue (String value)
	{
		setData(value);
	}

// org.w3c.dom.Data impl.

		public String
	getData()
	{
		if (dataString == null)
			dataString = dataBuffer.toString();
		
		return dataString;
	}

		public void               
	setData(String arg)
	{
		dataString = arg;
		dataBuffer = null;
	}

    public int            
	getSize()
	{
		return (dataString != null) ? dataString.length() : dataBuffer.length();
	}

    public int            
	getLength()
	{
		return (dataString != null) ? dataString.length() : dataBuffer.length();
	}

		public String
	substringData(int start, int count)
		throws DOMException
	{
		if (dataString != null)
			return dataString.substring(start, start + count);
		else
			return dataBuffer.toString(start, start + count);
	}

		public void
	appendData(String arg)
	{
		if (dataBuffer == null)
		{
			dataBuffer = new FreedomTextBuffer(dataString.length() + arg.length());
			dataBuffer.append(dataString);
		}

		dataString = null;
		dataBuffer.append(arg);
	}

		public void
	insertData(int offset, String arg)
		throws DOMException
	{
		if (dataBuffer == null)
		{
			dataBuffer = new FreedomTextBuffer(dataString.length() + arg.length());
			dataBuffer.append(dataString);
		}

		if (offset < 0 || offset > dataBuffer.length())
			throw Freedom.exception(DOMException.INDEX_SIZE_ERR);

		dataString = null;
		dataBuffer.insert(offset, arg);
	}

		public void
	deleteData(int offset, int count)
		throws DOMException
	{
		if (dataBuffer == null)
			dataBuffer = new FreedomTextBuffer(dataString);

		if (offset < 0 || offset > dataBuffer.length())
			throw Freedom.exception(DOMException.INDEX_SIZE_ERR);

		dataString = null;
		dataBuffer.delete(offset, count);
	}

		public void
	replaceData(int offset, int count, String arg)
		throws DOMException
	{
		if (dataBuffer == null)
			dataBuffer = new FreedomTextBuffer(
				dataString.length() - count + arg.length());

		if (offset < 0 || offset > dataBuffer.length())
			throw Freedom.exception(DOMException.INDEX_SIZE_ERR);

		dataString = null;
		dataBuffer.replace(offset, count, arg);
	}
}
