package edu.npac.iwt.dom;

import org.w3c.dom.*;

//
//
// FreedomDocument
//
//
public class 
FreedomDocument extends FreedomFragment implements Document
{
   DOMImplementation	domImpl;	
   DocumentType		    docType;
   Element				docRoot;

   public
   FreedomDocument ()
   {
		super(DOCUMENT_NODE);

		setMasterDoc(this);
   }

   public
   FreedomDocument (Document doc, String args)
   {
		super(DOCUMENT_NODE);
		setMasterDoc(this);
   }

   public void
   setDOMImplementation (DOMImplementation domImpl)
   { this.domImpl = domImpl; 	}

   public void              
   setDocumentElement(Element arg)
   {
		try
		{
			if (docRoot != null)
				replaceChild(arg, docRoot);
			else
				insertBefore(arg, null);
		}
		catch (DOMException ex)
		{}

		docRoot = arg;
   }

// org.w3c.dom.Node impl.

		public String
	getNodeName ()
	{
		return "#document";
	}

// org.w3c.dom.Document impl.

		public DocumentType
	getDoctype()
	{
		return docType;
	}

		public DOMImplementation
	getImplementation()
	{
		return domImpl;
	}

		public Element              
	getDocumentElement()
	{
		return docRoot;
	}

	public Element
	createElement(String tagName)
	{
         if( docRoot!=null && docRoot.getTagName().equals("HTML") )
             throw new IWTDOMException(DOMException.NOT_SUPPORTED_ERR);
		return new FreedomElement(tagName);
	}

		public DocumentFragment
	createDocumentFragment()
	{
		return new FreedomFragment();
	}

		public Text              
	createTextNode(String data)
	{
		return new FreedomText(data);
	}

	public Comment
	createComment(String data) { return new IWTComment(data); }

	public CDATASection              
	createCDATASection(String data)
	{ 
         if( docRoot!=null && docRoot.getTagName().equals("HTML") )
             throw new IWTDOMException(DOMException.NOT_SUPPORTED_ERR);
         return new FreedomCDATASection(data); 
      }

	public ProcessingInstruction              
	createProcessingInstruction(String target, String data)
	{  
      System.out.println(" in createProcessingInstruction ");
         if( docRoot!=null && docRoot.getTagName().equals("HTML") )
             throw new IWTDOMException(DOMException.NOT_SUPPORTED_ERR);
         return new FreedomPI(target, data);
      }

	public Attr              
	createAttribute(String name)
	{ return new FreedomAttribute(name); }

	public Entity              
	createEntity()
	{ return new FreedomEntity();	}

	/*public EntityReference              
	createEntityReference()
	{ return new FreedomEntityReference(); }*/

	public EntityReference              
	createEntityReference(String args)
	{ return new IWTEntityReference(this,args); }

	public NodeList              
	getElementsByTagName(String name)
	{
		if (docRoot != null)
			return docRoot.getElementsByTagName(name);
		else
			return null;
	}

   /**
   */
   public Document getOwnerDocument() { return this; }

}

