package edu.npac.iwt.dom;

import org.w3c.dom.*;

//
//
// FreedomDriverContext
//
//
public class FreedomDriverContext 
{
	protected FreedomDriver		driver;
	protected FreedomDocument	document;
	protected FreedomContainer	current;

	public
	FreedomDriverContext ()
	{
		this(null);
	}

	public
	FreedomDriverContext (FreedomDriver driver)
	{
		this.driver = driver;

		reset();
	}

	public void
	reset ()
	{
		document = new FreedomDocument();
		document.setDOMImplementation(driver);

			// start with the document as current container node
		current = document;
	}

		public FreedomDocument
	getDocument ()
	{
		return document;
	}

		public FreedomContainer
	getContainer ()
	{
		return current;
	}

		public void
	enter (FreedomContainer container)
	{
		current = container;
	}

		public void
	leave ()
	{
		if (current != null)
			current = current.parent;
	}

		public void
	add (FreedomElement elem)
		throws DOMException
	{
		if (current != null)
		{
			if (current.parent != null)
				current.appendChild(elem);
			else
				document.setDocumentElement(elem);
		}	
	}

		public void
	add (FreedomComponent comp)
		throws DOMException
	{
		if (current != null)
			current.appendChild(comp);
        else 
            document.appendChild(comp);
	}
}
