package edu.npac.iwt.dom;

import java.util.*;
import org.w3c.dom.*;

//
//
// FreedomElement
//
//
public class 
FreedomElement extends FreedomContainer implements Element
{
   String				name;
   FreedomNamedNodeMap		attributes=null;

   public
   FreedomElement (String name)
   {
      super(ELEMENT_NODE);
      this.name = name;
   }

   public
   FreedomElement (Document _doc, String name)
   {
      super(ELEMENT_NODE);
      this.name = name;
   }

    // org.w3c.dom.Node impl.

	public String
	getNodeName ()
	{
		return name;
	}

    // Element interface implementation methods

	public String            
	getTagName()
	{
		return name;
	}

	public NamedNodeMap     
	getAttributes()
	{
		return attributes;
	}

	public String
	getAttribute(String name)
	{
		if (attributes == null) return null;

		Node attr = attributes.getNamedItem(name);
		return attr != null ? attr.getNodeValue() : null;
	}

	public void
	setAttribute(String name, String value)
	{
        //System.out.println(" name: " +name+" value: "+value);
		if (attributes == null)
			attributes = new FreedomNamedNodeMap();

		Node attr = attributes.getNamedItem(name);
		if (attr != null)
			attr.setNodeValue(value);
		else
			attributes.setNamedItem(new FreedomAttribute(name, value));
	}

	public void
	removeAttribute(String name)
	{
		if (attributes != null)
			attributes.removeNamedItem(name);
	}

		public Attr
	getAttributeNode(String name)
	{
		return attributes != null ? (Attr)attributes.getNamedItem(name) : null;
	}

	public Attr              
	setAttributeNode(Attr newAttr)
	{
		if (attributes == null)
			attributes = new FreedomNamedNodeMap();

		attributes.setNamedItem(newAttr);
		return (Attr)attributes.getNamedItem(newAttr.getName());
	}

	public Attr
	removeAttributeNode(Attr oldAttr)
	{
		if (attributes != null)
			attributes.removeNamedItem(oldAttr.getNodeName());
		return null;
	}

		public NodeList      
	getElementsByTagName(String name)
	{
		FreedomNodeList result = new FreedomNodeList();
		findElementsByTagName(("*".equals(name) ? null : name), result);
		return result;
	}

		public void              
	normalize()
	{
		//TODO
	}

// private methods

		void      
	findElementsByTagName(String name, FreedomNodeList result)
	{
		if (!hasChildNodes())
			return;

		for (Node node = getFirstChild(); node != null; node = node.getNextSibling())
        {
            //System.out.println("looking: "+node.getNodeName()+" for "+name);
			if (node.getNodeType() == Node.ELEMENT_NODE &&
				(name == null || ((Element)node).getTagName().equalsIgnoreCase(name)))
			{
				result.addElement(node);
				((FreedomElement)node).findElementsByTagName(name, result);
			}

        }// end of if
	}
}

