package edu.npac.iwt.domUtil;

/**
*/
import java.net.*;
import java.io.*;

import org.w3c.dom.*;

import edu.npac.iwt.dom.*;


/**
*
* Reeads the PDU input file and produces the frequency information about
* each type of pdu and total number of pdus in the file.
*
* @author H. Timucin Ozdemir
* @date   October 19, 1998 (Last Updated October 22, 1998)
*
*/
public class printDOM
{

   /**
   */
   public printDOM() {}
 
   /**
   */
   public static void
   print(org.w3c.dom.Document doc, String header, PrintWriter out)
   {
      //PrintWriter out = new PrintWriter(ou);
      //out.println("<?XML ?>");
      out.println(header);

      if(doc.hasChildNodes()) printDOM.printChildNodes((Node)doc, out);

      out.flush();

   }// end of writeXML()

   /**
   */
   public static void printElement(org.w3c.dom.Element aNode, PrintWriter out)
   {
       out.print("<"+aNode.getTagName());
       NamedNodeMap attribs = aNode.getAttributes();
       int i=0;
       if(attribs!=null)
       while( i<attribs.getLength() )
       {
          Attr anAttr = (Attr) attribs.item(i);
          if( anAttr!=null && anAttr.getSpecified())
          {
             out.print(" "+anAttr.getName()+"=");
             out.println("\""+anAttr.getValue()+"\"");

          }// end of if
            
          i++;
       }// end of while

       String value = aNode.getNodeValue();
       if(value!=null) 
       {
         out.print(">");
         out.print(value);
         out.println("</"+aNode.getTagName()+">");

       } else 
         { 
            if( aNode.hasChildNodes() )
            {
                out.println(">");
                printDOM.printChildNodes(aNode, out);
                out.println("</"+aNode.getTagName()+">");

            } else out.println("/>");

         } 

      out.flush();

   }// end of printElement()

   /**
   */
   static void printAttributes(org.w3c.dom.Node aNode, PrintWriter out)
   {
   }// end of printAttributes()

   /**
   */
   static void printText(org.w3c.dom.Text aNode, PrintWriter out)
   {
      String data = aNode.getData();
      out.println(data);
      out.flush();

   }// end of printText()

   /**
   */
   static void printCDATA(org.w3c.dom.CDATASection aNode, PrintWriter out)
   {
      String data = aNode.getData();
      out.println("<!CDATA["+data+"]]>");
      out.flush();
   }// end of printCDATA()

   /**
   */
   static void printComment(org.w3c.dom.Comment aNode, PrintWriter out)
   {
      String data = aNode.getData();
      out.println("<--"+data+"-->");
      out.flush();

   }// end of printComment()

   /**
   */
   static void printPI(org.w3c.dom.ProcessingInstruction aNode, PrintWriter out)
   {
      String data = aNode.getData();
      out.println("<?"+aNode.getNodeName()+" "+data+"?>");
      out.flush();

   }// end of printPI()

   /**
   */
   static void printEntity(org.w3c.dom.Entity aNode, PrintWriter out)
   {
      out.println("<!ENTITY "+aNode.getPublicId()+" "+aNode.getSystemId()+">");

      out.flush();

   }// end of printEntity()

   /**
   */
   static void printNode(org.w3c.dom.Node aNode, PrintWriter out)
   {
      short nodeType = aNode.getNodeType();

      switch(nodeType)
      {
        case Node.ELEMENT_NODE       : printDOM.printElement((Element)aNode,out); break;
        case Node.TEXT_NODE          : printDOM.printText((Text)aNode,out); break;
        case Node.CDATA_SECTION_NODE : printDOM.printCDATA((CDATASection)aNode,out); break;
        case Node.COMMENT_NODE       : printDOM.printComment((Comment)aNode,out); break;
        case Node.PROCESSING_INSTRUCTION_NODE : printDOM.printPI((ProcessingInstruction)aNode,out); break;
        case Node.ENTITY_NODE : printDOM.printEntity((Entity)aNode,out); break;
      }// end of switch()

   }// end of printNode()

   /**
   */
   static void printChildNodes(org.w3c.dom.Node doc, PrintWriter out)
   {
      NodeList aNodeList = doc.getChildNodes();
      int i=0;

      while( i<aNodeList.getLength())
      {
         Node aNode = aNodeList.item(i);
         if(aNode!=null) printDOM.printNode(aNode,out);
         i++;

      }// end of while

      out.flush();

   }// end of printChildNodes()

   /**
   */
   public static void printTagOfChildren(org.w3c.dom.Node doc, PrintWriter out)
   {
      NodeList aNodeList = doc.getChildNodes();
      int i=0;

      while( aNodeList!=null && i<aNodeList.getLength() )
      {
         Node a = aNodeList.item(i);
         if(a !=null) 
            out.println("n:"+a.getNodeName()+" ny:"+a.getNodeType());
         i++;

      }// end of while

      out.flush();

   }// end of printTagOfChildren()

}// end of printDOM()

