package edu.npac.iwt.rdf;

import iwt.rdf.*;

import org.w3c.dom.Document;
import edu.npac.iwt.dom.FreedomElement;

import java.util.*;

/**
*
* @author H. Timucin Ozdemir
* @date   Februarary 22, 1999
*
*/
public class 
Description extends FreedomElement implements DescriptionElement 
{

   boolean isAbout;
   String  about;
   boolean isID;
   String  ID;
   IWTPropertyList  properties ;

   public Description(Document doc,String value, boolean _isAbout) 
   { super("rdf:Description"); 
     if(  _isAbout ) setAbout(value);
     else  setID(value);
     properties = new IWTPropertyList(doc);

   } ;

   void setAbout(String value)
   {
     isAbout=true;
     isID=false;
     about=value;
   }// end of setAbout()

   void setID(String value)
   {
     isAbout=false;
     isID=true;
     ID=value;
   }// end of setID()

   public boolean   isAbout() { return isAbout; } ;

   public String    getAbout() throws RDFException
   {
     if( isAbout ) return about;
     else throw new IWTRDFException(RDFException.NOT_ABOUT_ERR);
   }

   public boolean   isID() { return isID;} ;

   public String    getID()    throws RDFException
   {
      if( isID ) return ID;
      else throw new IWTRDFException(RDFException.NOT_ID_ERR);
   }

   protected void addPropertyElement(PropertyElement aProp)
   {
     if( properties!=null && aProp!=null ) properties.addElement(aProp);

   }// end of addPropertyElement()

   public PropertyList getProperties() { return properties; }

}

