package edu.npac.iwt.rdf;

import java.util.*;

import org.w3c.dom.*;
import iwt.rdf.*;

import edu.npac.iwt.dom.*;

/**
*
* @author H. Timucin Ozdemir
* @date   February 22, 1999
*
*/
public class IWTPropertyList implements PropertyList 
{

   Vector   properties = new Vector();
   int      current=0; // iterator
   Document doc;

   public IWTPropertyList(Document _doc)
   { doc=_doc; }

   /**
   */
   public PropertyElement  
   item(int i) throws RDFException
   {
      PropertyElement ret=null;

      if(i>=0 && i<properties.size()) 
         ret = (PropertyElement)properties.elementAt(i);

      else throw new IWTRDFException(RDFException.INDEX_SIZE_ERR);

      return ret;

   }// end of item()

   /**
   */
   public PropertyElement 
   next() throws RDFException { return item(current++); }

   /**
   */
   public void reset() { current=0; }

   /**
   */
   public int  getLength()  { return properties.size(); }

   protected void addElement(PropertyElement aNode)
   {
      if( aNode!=null ) properties.addElement(aNode);
   }

}// end of IWTPropertyList

