package edu.npac.iwt.rdf;

import iwt.rdf.*;
import org.w3c.dom.Node;
import org.w3c.dom.Document;

import edu.npac.iwt.dom.*;


/**
*
* @author H. Timucin Ozdemir
* @date   February 22, 1999
*
*/
public class 
RDFProperty extends FreedomElement implements PropertyElement {

  String  tagName;
  boolean isResource;
  boolean isLiteral;
  String  resource;
  Node    value;

  public RDFProperty(Document _doc, String _tagName, String _rname) 
  { 
     super(_doc,_tagName); 
     tagName=_tagName; 
     isResource=true;
     isLiteral=false;
     resource=_rname;

  }// end of Constructor

  public RDFProperty(Document doc, String _tagName, Node _value)  
  { 
     super(doc,_tagName); 
     tagName=_tagName; 
     isResource=false;
     isLiteral=true;
     value=_value;

  }// end of Constructor

  public String   getTagName() { return tagName; }

  public boolean  isResource() { return isResource; }

  public String    getResource() throws RDFException
  {
    if(isResource) return resource;
    else throw new IWTRDFException(RDFException.NOT_RESOURCE_ERR);
    
  }// end of getResource()

  public Node      getValue()    throws RDFException 
  {
    if(isLiteral) return value;
    else throw new IWTRDFException(RDFException.NOT_LITERAL_ERR);
  }

  protected void 
  setResource(String value) 
  { isResource=true; 
    isLiteral=false; 
  }

}

