package fr.dyade.koala.xml.xsl;
import org.w3c.dom.*;
/** Attribute.java
 */
/** This class defines an attribute in the document.
 *  @author Jrmy CALLES
 *  @version 0.7b1
 */
import fr.dyade.koala.xml.xsl.exception.*;
public class Attribute{
    /** The Name of the attribute*/
    protected String  name;
    /** Should the attribute have a value */
    protected boolean has_value;
    /** The value of the attribute */
    protected String  value;
    
    /** Initializer
     *  @param name        the name of the attribute
     *  @param has_value   should it have a value (not #IMPLIED)
     *  @param value       its value
     */
    public Attribute(String typ,boolean has,String val){
	name      = new String (typ);
	has_value = has;
	if ((has_value == false) && (value != null)){
	    throw new XSLFatalErrorException("Error: Bad initial value for attribute \"" + typ + "\"\n\t" +
					 "has-value is set to \"no\" but value is not null: " + value);
	} else {
	    value = val;	
	}
    }

    /** toString */
    public String toString(){
	return XSLTags.ATTRIBUTE_QUALIFIER + XSLTags.ATTRIBUTE_OP + name + 
	    XSLTags.ATTRIBUTE_IS1 + value+ XSLTags.ATTRIBUTE_IS_SEP1 + XSLTags.ATTRIBUTE_CP;
    }
    /** attribute's name accessor*/
    public String getName(){
	return name;
    }

    /** attribute's should-have-a-value accessor */
    public boolean hasValue(){
	return has_value;
    }

    /** attribute's value accessor */
    public String getValue(){
	return value;
    }    
    /** Count Attribute (give a Mark for comparison) */
    public float getAttributeCount(){   
	if (value == null){
	    return 1;
	}else{
	    return 1.5f;
	}	    
    }
    /** compatible:. <br>
     *  return <i>true</i> if the XML DOM Element has the same name,
     *  and the same value (if has-value is set).<br>
     *  OtherWise: return false.
     */
    public boolean compatible(Element node){
	org.w3c.dom.Attr att = node.getAttributeNode(name);
	if (att == null){
	    if (has_value == false){
		return true;
	    }else{
		return false;
	    }
	}else{
	    if ((value == null) && (!att.getValue().equals(""))){
		return true;
	    }else if (att.getValue().equals(value)){
		return true;
	    }else{
		return false;
	    }
	}
    }
}
