package fr.dyade.koala.xml.xsl;
/** DefaultDocumentHandler.java 
 */
import java.io.*;
/** This class defines a Defaut Document Handler
 *  @author Jrmy CALLES
 *  @version 0.7b1
 *  @see OutputDocumentHandler
 */
public class DefaultDocumentHandler implements OutputDocumentHandler{

    PrintWriter out;

    public DefaultDocumentHandler(){
	out = new PrintWriter(System.out);
    }

    public void setOutputStream(OutputStream s){
	out = new PrintWriter(s);
    }

    public DefaultDocumentHandler(OutputStream s){
	out = new PrintWriter(s);
    }
    /**
     * Receive notification of the start of a document.
     */
    public void startDocument (){
    }
   /**
    * Receive notification of the end of a document.
    */
    public void endDocument (){
    }
    /**
     * Receive notification of the beginning of an element.
     */
    public void startElement (String name, boolean hasAttributes,boolean isEmpty){
	String tmp = "<"+ name;
	if (hasAttributes == false){
	    if (isEmpty == true){
		tmp += "/>";    
	    }else{
		tmp += ">";    
	    }
	}
	out.print(tmp);
	out.flush();
    }
    /**
     * Receive notification of the end of an element.
     **/
    public void endElement (String name){
	out.print("</" + name + ">");	
	out.flush();
    }
    /**
     * Receive notification of a String
     */
    public void string (String s){
	out.print(s);
	out.flush();
    }
    /**
     * Receive notification of an Attribute
     */
    public void attribute(String name, String value, boolean isLast, boolean elementIsEmpty){
	String tmp = " " + name + "=\"" + value + "\"";
	if (isLast){
	    if (elementIsEmpty == false){
		tmp += ">";
	    }else{
		tmp += "/>";
	    }		
	}
	out.print(tmp);
	out.flush();
    }
} 
