package fr.dyade.koala.xml.xsl;
/** NameSpaces.java
 */
import fr.dyade.koala.xml.util.Properties;
import java.io.*;
import java.net.*;
/** This class defines how to support NameSpaces
 *  @author Jrmy CALLES
 *  @version 0.7b
 */
public class NameSpace{
    protected String name;
    protected String expandedName;
    protected OutputDocumentHandler handlerToUse;

    private NameSpace(){};

    public NameSpace(String n, String en,XSLErrorHandler err){
	name = n;
	expandedName = en;
	handlerToUse = createInstance(en,err);
    }

    public static NameSpace getDefault(){
	return new NameSpace("default","default",null);
    } 
    public OutputDocumentHandler getOutputHandler(){
	return handlerToUse;
    }
    /** Charger Statiquement les properties */
    public static OutputDocumentHandler createInstance(String ns_name, XSLErrorHandler err){
	String outputHandler = getHandlerName(ns_name);
	try{ 
	    Class outputClass;	   
	    outputClass = Class.forName(outputHandler);
	    Object outputInstance = outputClass.newInstance();
	    
	    if (!(outputInstance instanceof OutputDocumentHandler)){
		err.fatalError("OutputDocumentHandler named "+ outputHandler +
						  " does not support OutputDocumentHanlder interface");
	    }
	    return  (OutputDocumentHandler) outputInstance;
	}catch (Exception e){
	    err.fatalError("Unable to instantiate the Output Handler, " + outputHandler);
	}
	return null;

    }
    
    public static String getHandlerName(String ns_name){
	String tmp = prop.getProperty(ns_name);
	if (tmp == null){
	    return "fr.dyade.koala.xml.xsl.DefaultDocumentHandler";
	}else{
	    return tmp;
	}
    }
    
    protected static Properties prop = new Properties();	
    static {
	try {  
	    NameSpace n = new NameSpace();
	    InputStream f = n.getClass().getResourceAsStream("nameSpace.properties.xml");
	    prop.load(f);	    
	    f.close();
	} catch (Exception mre) {
	    System.err.println("Warning properties not found, using Default");
	}
    }
}   
