package fr.dyade.koala.xml.xsl;
/** DefaultDocumentHandler.java 
 */
import java.io.*;
/** This interface defines an OutputDocumentHandler
 *  @author Jrmy CALLES
 *  @version 0.7b1
 */
public interface OutputDocumentHandler{
    public void setOutputStream(OutputStream s);
    /**
    * Receive notification of the start of a document.
    */
    public abstract void startDocument (); 
    /**
    * Receive notification of the end of a document.
    */
     public abstract void endDocument ();
    /**
     * Receive notification of the beginning of an element.
     */
    public abstract void startElement (String name, boolean hasAttributes, boolean isEmpty);
    /**
     * Receive notification of the end of an element.
     **/
    public abstract void endElement (String name);
    /**
     * Receive notification of a String
     */
    public abstract void string (String s);  
    /**
     * Receive notification of an Attribute
     */
    public abstract void attribute(String name, String value, boolean isLast, boolean elementIsEmpty);  
}
