package fr.dyade.koala.xml.xsl;
/** XMLOutputDocumentHandler.java 
 */
import java.io.*;
/** This class defines an OutputDocumentHandler.
 *  &lt; are replaced by &amp;lt;
 *  @author Jrmy CALLES
 *  @version 0.7b1
 */
public class XMLOutputDocumentHandler implements OutputDocumentHandler{

    PrintWriter out;

    public XMLOutputDocumentHandler(){
	out = new PrintWriter(System.out);
    }

    public void setOutputStream(OutputStream s){
	out = new PrintWriter(s);
    }

    public XMLOutputDocumentHandler(OutputStream s){
	out = new PrintWriter(s);
    }
    /**
    * Receive notification of the start of a document.
    */
    public void startDocument (){
    }
    /**
    * Receive notification of the end of a document.
    */
    public void endDocument (){
    }
    /**
     * Receive notification of the beginning of an element.
     */
    public void startElement (String name, boolean hasAttributes,boolean isEmpty){
	String tmp = NEWLINE + AMPLT + name;
	if (hasAttributes == false){
	    if (isEmpty == true){
		tmp += "/>";
	    }else{
		tmp += ">";    
	    }
	}
	out.print(tmp);
    }
    /**
     * Receive notification of the end of an element.
     **/
    public void endElement (String name){
	out.print(NEWLINE + AMPLT +"/" + name + ">");	
	out.flush();
    }
    
    private String supressLt(String s){
	int i = s.indexOf(LT);
	while(i != -1){
	    String left  = s.substring(0,i);
	    String right = s.substring(i+1);
	    s = left + AMPLT + right;
	    i = s.indexOf(LT);
	}
	return s;
    }
   /**
     * Receive notification of a String
     */
    public void string (String s){
	s = supressLt(s);
	out.print(s);
    }
  /**
     * Receive notification of an Attribute
     */
    public void attribute(String name, String value, boolean isLast, boolean elementIsEmpty){
	String tmp = " " + name + "=\"" + value + "\"";
	if (isLast){
	    if (elementIsEmpty == false){
		tmp += ">";
	    }else{
		tmp += "/>";
	    }		
	}
	out.print(tmp);
    }
    
    // Constants:
    public static final String LT = "<";
    public static final String AMPLT = "&lt;";
    public static final String NEWLINE = "<BR>";
} 
