package fr.dyade.koala.xml.xsl;
/** ErrorHandler.java 
 */
import org.xml.sax.SAXException;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXParseException;
import java.io.*;
/** This interface defines an Error Handler
 *  @author Jrmy CALLES
 *  @version 0.7b1
 */
public interface XSLErrorHandler extends org.xml.sax.ErrorHandler{
    public void setOutputStream(OutputStream s);
    public void setPrintWriter(PrintWriter s);
    /**
    * Receive notification of a warning from the XSL engine
    */
    public abstract void warning (String error); 
    /**
    * Receive notification of an error from the XSL engine
    */
     public abstract void error (String error);
    /**
     * Receive notification of a fatal error from the XSL engine
     */
    public abstract void fatalError(String error);
    /**
     * Receive notification of a warning from the XML SAX Parser
     */
    public void warning(SAXParseException e) throws SAXException;
    /**
     * Receive notification of an error from the XML SAX Parser
     */
    public void error(SAXParseException e) throws SAXException;
    /**
     * Receive notification of a fatal error from the XML SAX Parser
     */
    public void fatalError(SAXParseException e) throws SAXException;
    /**
     * print all preceding errors
     */
    public void printAll(int type);
}
