package fr.dyade.koala.xml.xsl;
/** XSLTags.java
 */
/** This class defines some constants, such as the name of
 *  the XSL Commands.
 *  @author Jrmy CALLES
 *  @version 0.7b
 */
public class XSLTags{
    /** Preambule */
    public static final String XSL = "xsl:";
    /** NameSpace */
    public static final String XMLNS = "xmlns:";
    /** Xsl Style Sheet*/ 
    public static final String STYLESHEET = XSL+"stylesheet";
    /** Result: result-ns*/
    public static final String STYLESHEET_RESULT = "result-ns";
    /** Result: format */
    public static final String RESULT_FORMAT = "format";
    /** Result: xml */
    public static final String RESULT_XML = "xml";    
    /** Xsl Import */
    public static final String IMPORT = XSL+"import";    
    /** Xsl Include */
    public static final String INCLUDE = XSL+"include"; 
    /** Xsl Href Attribute */
    public static final String HREF = "href";       
    /** Xsl Macros */
    public static final String DEFINE_MACRO = XSL+"define-macro";    
    /** Xsl Macros Content */
    public static final String MACRO_CONTENT = XSL+"contents";
    /** Xsl Macros Invoke */
    public static final String MACRO_INVOKE = XSL+"invoke";
    /** Xsl Macros Invoke-macro */
    public static final String MACRO_INVOKE_MACRO = "macro";
    /** Xsl Macros Invoke_name */
    public static final String MACRO_NAME = "name"; 
    /** Xsl Macros Args */
    public static final String MACRO_ARG_VALUE = "value";
    /** Xsl Macros Args-Invoke */
    public static final String MACRO_ARG_INVOKE = XSL+"arg";
    /** Xsl Macros Args */
    public static final String MACRO_ARG_DEFINE = XSL+"macro-arg";
    /** Xsl Macros Args_Default */
    public static final String MACRO_ARG_DEFAULT = "default";
    /** Xsl Constant */
    public static final String DEFINE_CONSTANT = XSL+"define-constant";    
    /** Xsl value template*/
    public static final String VALUE_CBRACE ="}";    
    /** Xsl access Constant Brace*/
    public static final String CONSTANT_CBRACE =")}";    
    /** Xsl access Constant */
    public static final String CONSTANT ="constant";    
    /** Xsl access Constant Brace*/
    public static final String CONSTANT_OBRACE ="{";    
    /** Xsl access Constant Brace */
    public static final String CONSTANT_BRACE ="{"+CONSTANT+"(";    
    /** Xsl Constant Name */
    public static final String CONSTANT_NAME = "name";    
    /** Xsl Constant Value */
    public static final String CONSTANT_VALUE = "value";    
    /** Xsl Template */
    public static final String TEMPLATE = XSL+"template";
    /** Xsl Empty */
    public static final String EMPTY = XSL+"empty";
    /** Xsl Process Children */ 
    //public static final String CHILDREN = XSL+"process-children";
    public static final String CHILDREN = XSL+"process-children";
    /** Xsl Text */
    public static final String TEXT = XSL+"text";
    /** Xsl Number */
    public static final String NUMBER = XSL+"number";
    /** Xsl Number From*/
    public static final String NUMBER_FROM = "from";
    /** Xsl Number Level*/
    public static final String NUMBER_LEVEL = "level";
    /** Xsl Number Count*/
    public static final String NUMBER_COUNT = "count";
    /** Xsl Number Format*/
    public static final String NUMBER_FORMAT = "format";
    /** Xsl Value of */
    public static final String VALUE_OF = XSL+"value-of";
    /** Xsl Value of expr */
    public static final String VALUE_OF_EXPR = "expr";
    /** Xsl Eval */
    public static final String EVAL = XSL+"eval";
    /** Xsl For-each */
    public static final String FOR_EACH = XSL+"for-each";  
    /** Xsl For-each Select*/
    public static final String FOR_EACH_SELECT = "select";
    /** Xsl Process */
    public static final String SELECT = XSL+"process";
    /** Xsl Process, select elements */
    public static final String PROCESS_SELECT = "select";
    /** Xsl PI */
    public static final String PI = XSL+"pi";
    /** Xsl Comment*/
    public static final String COMMENT = XSL+"comment";
    /** Match */
    public static final String PATTERN = "match";
    /** Root */
    public static final String ROOT_PATTERN0 = "/";
    /** One Element separator: * */
    public static final String ELEMENT_PATTERN0 = "*";
    /** Or Separator */
    public static final String OR_SEP = "|";    
    /** Multi Level Number Separator */
    public static final String MULTI_SEP = "|";    
    /** Separator */
    public static final String SEP = "/";    
    /** Any Separator */
    public static final String ANY_SEP = "//";    
    /** Parent Element */
    public static final String PARENT_ELEMENT = "..";    
    /** This Element */
    public static final String CURRENT_ELEMENT = ".";    
    /** Ancestor Qualifier */
    public static final String ANCESTOR = "ancestor";    
    /** Ancestor Open */
    public static final String ANCESTOR_OSEP = "(";        
    /** Ancestor Close */
    public static final String ANCESTOR_CSEP = ")";        
    /** Child Qualifier */
    public static final String CHILD_QUALIFIER = "child";
    /** Qualifier Open */
    public static final String QUALIFIER_OP = "[";
    /** Qualifier Close */
    public static final String QUALIFIER_CP = "]";
    /** Qualifier Separator */
    public static final String QUALIFIER_SEP = ",";
    /** Attribute Qualifier*/
    public static final String ATTRIBUTE_QUALIFIER = "attribute";
    /** Attribute Equals Separator 1*/
    public static final String ATTRIBUTE_IS_SEP1 = "'";
    /** Attribute Equals Separator 2*/
    public static final String ATTRIBUTE_IS_SEP2 = "\"";
    /** Attribute Equals Separator*/
    public static final String ATTRIBUTE_IS1 = "=" + ATTRIBUTE_IS_SEP1;
    /** Attribute Equals Separator*/
    public static final String ATTRIBUTE_IS2 = "=" + ATTRIBUTE_IS_SEP2;
    /**Attributes Separator*/
    public static final String ATTRIBUTE_OP = "(";
    /**Attributes Separator*/
    public static final String ATTRIBUTE_CP = ")";
    /** Other */
    public static final String NULL_ELEMENT = "<" + XSL + "element>";   
    /** Other */
    public static final String ANY_ELEMENT = "<" + XSL + "any>";
    /** The pattern */ 
    public static final int ELEMENT_PATTERN = 1;
    /** The pattern */ 
    public static final int TARGETELEMENT_PATTERN = 2;
    /** The pattern */ 
    public static final int ROOT_PATTERN = 3;
    /** The pattern */ 
    public static final int ANY_PATTERN = 4;
    /** The pattern */ 
    public static final int ANCESTOR_PATTERN = 5;
    /** The pattern */ 
    public static final int CHILD_PATTERN = 6;
    /** The pattern */ 
    public static final int PARENT_PATTERN = 7;
    /** The pattern */ 
    public static final int ATTRIBUTE_PATTERN = 8;
}
