package fr.dyade.koala.xml.xsl.slideMaker;
import java.util.*;
import java.io.*;

public class Main{
    protected static boolean verbose = false;
    protected static String files[]; 
    protected static String slideName; 
    protected static ResourceBundle resources=null;

    public static void main (String args[]) throws Exception{
	// Command line parsing 
	ParseCommand(args);
	// Parsing Files
	ParseFiles();
    }
    
    /** Parsing Files */
    public static void ParseFiles() throws Exception{
	for (int i = 0; i < files.length; i++){
	    String tmp = files[i];
	    System.out.println("One file to multiple html: " + tmp);
	    // Transformation du Document
	    HtmlTransform t = new HtmlTransform(tmp,slideName);
	}
    } 

    /** Parsage des arguments de la ligne de commande */
    private static void ParseCommand(String args[]) {
	int NbFiles = 0;
	int i;
	for (i = 0; (i < args.length)&&(NbFiles == 0); i++){
	    if (args[i].equals("-v")){
		verbose = true;
		System.err.println("Verbose mode: on");
	    }else if (args[i].equals("-o")){
		slideName = args[++i];	       
	    }else if (args[i].equals("-help")){
		System.err.println("Usage: [-v|-help] -o outFilename -r xslUrl [xmlUrl]*");
		System.exit(1);	
	    }else{
		NbFiles = args.length - i;
		if (NbFiles > 1){
		    System.err.println("Error: Only one XML file.");
		    System.exit(1);
		}
	    }	    
	}
	// Construction du tableau de fichiers
	if (NbFiles == 0){
	    System.err.println("Error: You haven't give me any XML files");
	    System.exit(1);	
	}
	files = new String[NbFiles];
	if (NbFiles > 0){
	    System.arraycopy(args,
			     i-1,
			     files,
			     0,
			     NbFiles);
	}
    }  

}
