package fr.dyade.koala.xml.xsl.util;
/** DOMParse.java 
 */
import org.w3c.dom.*;
/** This class is used to construct the DOM Document
 *
 *  @see fr.dyade.koala.xml.xsl.XSLTags
 *  @see fr.dyade.koala.xml.xsl.Pattern
 *  @version 0.7b1
 *  @author  Jeremy CALLES
 */
public class DOMContext{
    protected Document document;
    protected Node current;
    
    public DOMContext(Document doc){
	document = doc;
	current = doc;
    }

    public Document getDocument (){
	return document;
    }
    
    public void enter (Node container){
	current = container;
    }
    
    public void leave (){
	if (current.getNodeType() != Node.DOCUMENT_NODE){
	    // Il ne faut pas remonter trop haut (au dessus du Document)
	    if (current != null)
		current = current.getParentNode();
	}
    }
    
    public void add (Element elem) throws DOMException{
	if (current != null){
	    if (current.getParentNode() != null)
		current.appendChild(elem);
	    else{
		document.insertBefore(elem,null);
	    }
	}
    }

    public void add (Node comp) throws DOMException{
	if (current != null)
	    current.appendChild(comp);
    }
}
