package iwt.web.server;

import java.io.*;
import java.util.*;

/**
*/
public class HttpRequest  
{
  String      data;
  String      method;
  String      uri;
  String      qstr;
  String      protocol;
  InputStream input;
    
  public HttpRequest(String _data) { parseData(_data); }
    
  void parseData(String _data) 
  {
    data = _data;

    StringTokenizer st = new StringTokenizer(data);

    method = st.nextToken();

    parseQStr(st.nextToken());

    if (st.hasMoreTokens()) protocol = st.nextToken();

  }// end of parseData()

  /**
  * Extracts the QueryString from the URI field.
  */
  void parseQStr(String _data) 
  {
    if( _data!=null )
    {
      uri = _data;
      int aIndex = _data.indexOf('?');
      if(aIndex>0 && aIndex<_data.length()) 
      {  
         qstr=_data.substring(aIndex+1,_data.length());
         uri    = _data.substring(0,aIndex);

      }// end of if
    }// end of if

  }// end of parseData()

  public String getMethod() { return method; }

  public String getUri() { return uri; }

  public String getQStr() { return qstr; }

  public String getProtocol() { return protocol;}

  public void   setInputStream(InputStream in) { input=in;}

  public InputStream getInputStream() { return input;}

  public String getPrefix()
  {
    String ret = null;
    int a1 = uri.indexOf('/');

    if(a1>0&&a1<uri.length()) ret = uri.substring(1,a1);

    return ret;

  }// end of getPrefix()

  public String toString() 
  {
    String ret = "";
    if(method!=null)   ret += (method+" ");
    if(uri!=null)      ret += uri;
    if(qstr!=null)     ret += ("?"+qstr);
    if(protocol!=null) ret += (" "+protocol);

    return ret;
 
  }// end of toString()

}// end of HttpRequest()
