package iwt.web.xmldomxsl;

import java.io.*;
import java.net.*;
import org.w3c.dom.*;

/**
* @author H. Timucin Ozdemir
* @date   March 9, 1999 (Updated March 9, 1999)
*/
public abstract interface DOMFactory extends XMLUtility
{
   /**
   * @param in It reads the XML document from the given file.
   * @return the DOM representation of XML document.
   */
   public abstract org.w3c.dom.Document openDocument(String xmlFile) 
          throws XMLUtilityException ;

   /**
   * @param in It reads the XML document from the InputStream.
   * @param in It reads the XML document from the given file.
   * @return the DOM representation of XML document.
   */
   public abstract org.w3c.dom.Document openDocument(InputStream in, String xmlFile) 
          throws XMLUtilityException ;

   /**
   * @param in It reads the XML document from the given URL.
   * @return the DOM representation of XML document.
   */
   public abstract org.w3c.dom.Document openDocument(URL url) 
          throws XMLUtilityException ;

}
