package iwt.web.xmldomxsl;

import java.io.OutputStream;
import java.net.*;

import org.w3c.dom.*;

/**
*
* @author Hasan Timucin Ozdemir
* @date   February 9, 1999 (Updated February 9, 1999)
*/
public abstract interface XSLProcessor extends DOMFactory
{
   /**
   * @param doc  The URL of the document.
   * @param xsl  The URL of the file containing xsl rules.
   * @param pout The output stream 
   */
   public abstract void applyXSLRules(URL doc, URL xsl, OutputStream pout)
          throws XMLUtilityException;

   /**
   * @param doc  The file name of the document.
   * @param xsl  The name of the file containing xsl rules.
   * @param pout The output stream 
   */
   public abstract void applyXSLRules(String doc, String xsl, OutputStream pout)
          throws XMLUtilityException;

   /**
   * @param doc  The Document object.
   * @param xsl  The xsl rules as a Document object.
   * @param pout The output stream 
   */
   public abstract void 
   applyXSLRules( org.w3c.dom.Document doc, org.w3c.dom.Document xsl, 
                  OutputStream pout)
          throws XMLUtilityException;

}// end of XSLProcessor

