package test.lotus;

import java.io.*;
import java.net.*;

import org.w3c.dom.*;

import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;

import edu.npac.iwt.*;
import iwt.web.xmldomxsl.*;

/**
* It encapsulates the Lotus XSL Processor.
* 
* <table>
* <tr><td>org.w3c.domFactory</td><td>:</td><td>DOM Factory</td></tr>
* </table>
*
* @author Hasan Timucin Ozdemir
* @date   February 9, 1999
*
* @see XSLProcessor
*
*/
public class 
LotusXSLProcessor implements iwt.web.xmldomxsl.XSLProcessor
{  
   String domFactory    = "edu.npac.iwt.IWTDOMFactory";
 
   /**
   */
   public void 
   setProperty(String pName, String pValue)
   {
     if( pName.equals("org.w3c.domFactory") )
     {
        try
        {
	    Class domClass   = Class.forName(pValue);;
	    	    
	    Object domFctry  = domClass.newInstance();
    
	    if ( domFctry instanceof iwt.web.xmldomxsl.DOMFactory ) domFactory = pValue;

        } catch(Exception e) {}

     }// end of if

   }// end of setProperty()

   /**
   * @return The Document object of the given XML document.^M
   */
   public org.w3c.dom.Document
   openDocument(String xmlFile) throws XMLUtilityException
   {
     throw new XMLUtilityException(XMLUtilityException.DOM_NOT_FOUND);
   }// end of openDocument()

   /**
   * @return The Document object of the given XML document.^M
   */
   public org.w3c.dom.Document
   openDocument(URL xmlFile) throws XMLUtilityException
   {
     throw new XMLUtilityException(XMLUtilityException.DOM_NOT_FOUND);
   }// end of openDocument()

   /**
   * @return The Document object of the given XML document.^M
   */
   public org.w3c.dom.Document
   openDocument(InputStream xmlFile, String xmlFileN) throws XMLUtilityException
   {
     throw new XMLUtilityException(XMLUtilityException.DOM_NOT_FOUND);
   }// end of openDocument()


   /**
   */
   public void 
   applyXSLRules(String doc, String xsl, OutputStream pout)
   {
     /*
     try
     {
       Class domClass   = Class.forName(domFactory);;
	    	    
	 Object domFctry  = domClass.newInstance();
    
	 if ( domFctry instanceof iwt.web.xmldomxsl.DOMFactory ) 
       {
         iwt.web.xmldomxsl.DOMFactory domPro = (iwt.web.xmldomxsl.DOMFactory)domFctry;

         Document xmlDoc = domPro.openDocument(doc);
         Document xslDoc = domPro.openDocument(xsl);

         applyXSLRules(xmlDoc,xslDoc,pout);

       }// end of if

     } catch(Exception e) {}
     */ 

     try
     {  
       ProcessXSL xmlProcessorLiason = new ProcessXSL();
       xmlProcessorLiason.m_canUseUserData = true;
       com.lotus.xsl.XSLProcessor processor = new com.lotus.xsl.XSLProcessor(xmlProcessorLiason);
       Document result = processor.process(doc,xsl,"System.out",new PrintWriter(pout));
       System.out.println("Output is produced!");
     } catch(Exception nxfe) {}

     
   }// end of applyXSLRules()

   /**
   */
   public void 
   applyXSLRules(org.w3c.dom.Document doc, org.w3c.dom.Document xsl, OutputStream pout)
   {
     //DefaultErrorHandler errHandler = new DefaultErrorHandler(); 

     try
     {  
       ProcessXSL xmlProcessorLiason = new ProcessXSL();
       xmlProcessorLiason.m_canUseUserData = true;
       com.lotus.xsl.XSLProcessor processor = new com.lotus.xsl.XSLProcessor(xmlProcessorLiason);
       Document result = processor.process(doc,xsl,"System.out",new PrintWriter(pout));

     } catch(Exception nxfe) {}

   }// end of applyXSLRules()

   /**
   */
   public void 
   applyXSLRules(URL doc, URL xsl, OutputStream pout)
          throws XMLUtilityException
   {
     throw new XMLUtilityException(XMLUtilityException.NOT_SUPPORTED_ERR);
   }// end of applyXSLRules()

}// end of LotusXSLProcessor
