
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.event.*;
import java.net.*;
import java.io.*;
import java.util.*;

/** W3C's DOM API */
import org.w3c.dom.*;

import org.w3c.dom.Document;

/** DOM Core Level 1 implemenetation */
import edu.npac.iwt.dom.*;
import edu.npac.iwt.domUtil.*;

import iwt.web.xmldomxsl.*;

/**
*
* @date March 8, 1999 (Updated March 8, 1999) 
* @author H. Timucin Ozdemir
*
*/
public class testdom 
{
  Properties  props;

  /**
  */
  public testdom(Properties _props) 
  {
     props = _props; 

  }// end of CONSTUCTOR

  /**
  */
  XMLDOMXSL getXMLDOMXSL()
  {
     iwt.web.xmldomxsl.XMLDOMXSL web = null;

     String xmldomxsl = props.getProperty("org.w3c.xmldomxsl");

     if( xmldomxsl!=null )
     {
         try
         {
           Class xmldomxslClass   = Class.forName(xmldomxsl);;
           Object xmldomxslIns  = xmldomxslClass.newInstance();
           System.out.println(" xmldomxsl:"+xmldomxsl);
           if ( xmldomxslIns instanceof iwt.web.xmldomxsl.XMLDOMXSL ) 
           {  
              web = (iwt.web.xmldomxsl.XMLDOMXSL)xmldomxslIns;
              web.setAll(props);

           }// end of if

         } catch(Exception e) {}

     }// end of if

     return web;

  }// end of getXMLDOMXSL()

  /**
  */
  void test(InputStream in, String fileName)
  {

     System.out.println("****test(InputStream in, String fileName)***");
     try
     {
        iwt.web.xmldomxsl.XMLDOMXSL web = getXMLDOMXSL();

        if(web!=null&&in!=null)
        {
           Document doc = web.openDocument(in,fileName);

           printDOM.printTagOfChildren((Node)doc,new PrintWriter(System.out));

           printDOM.print(doc,"",new PrintWriter(new FileOutputStream("out.ss"),true)); 
        }// end of if

     } catch( IOException ioe) 
       { System.out.println("There is no Such Page"); }
       catch( Exception ioe) 
       { System.out.println("There is no Such Page"); }
 
  }// end of test()

  /**
  */
  void test(URL fileName)
  {
      System.out.println("****test(URL fileName)***");

     try
     {
        iwt.web.xmldomxsl.XMLDOMXSL web = getXMLDOMXSL();

        if(web!=null)
        {
           Document doc = web.openDocument(fileName);

           printDOM.printTagOfChildren((Node)doc,new PrintWriter(System.out));

           printDOM.print(doc,"",new PrintWriter(new FileOutputStream("out.ss"),true)); 
        }// end of if

     } catch( IOException ioe) 
       { System.out.println("There is no Such Page"); }
       catch( Exception ioe) 
       { System.out.println("There is no Such Page"); }
 
  }// end of test()

  /**
  */
  public void test(String fileName)
  {

     try
     {
        InputStream in=null;

        if(fileName.startsWith("http://") )
        {
          try
          {
            URL url = new URL(fileName);
            in = url.openConnection().getInputStream();
            //test(url);

          } catch (Exception e) 
            { 
              in = null; 
              System.out.println("There is no Such Page"); 
            }

        } else in = new FileInputStream(fileName);

        if(in!=null) test(in,fileName);

     } catch( IOException ioe) 
       { System.out.println("There is no Such Page"); }
       catch( Exception ioe) 
       { System.out.println("There is no Such Page"); }
 
  }// end of test()

  /**
  * 
  */
  public static void 
  main(String[] args) 
  {
     int i=0; 
     Properties props = new Properties();
     String propName = "browser.properties";
     String inName   = "in.xml";

     try
     {
       while(i<args.length)
       {
         if( args[i].equals("-rule") && i<args.length-1) propName=args[++i];
         else if( args[i].equals("-in") && i<args.length-1) inName=args[++i];
         else i++;

       }// end of while

       props.load(new FileInputStream(propName));
       props.list(System.out);

     } catch(Exception e) {}

     testdom tdom = new testdom(props);

     tdom.test(inName);

  }// end of main

}// end of TinyBrowser

